<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/support vector machine/model/inc/svm.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('svm_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">svm.h</div></div>
</div><!--header-->
<div class="contents">
<a href="svm_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">*  @file svm.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">*  @brief File containing declaration of the support vector machine class.</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;cmath&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;<a class="code" href="_me_l_on_8h.html">MeLOn.h</a>&quot;</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#include &quot;<a class="code" href="exceptions_8h.html">exceptions.h</a>&quot;</span></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &quot;<a class="code" href="kernel_8h.html">kernel.h</a>&quot;</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#include &quot;<a class="code" href="scaler_8h.html">scaler.h</a>&quot;</span></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#include &quot;<a class="code" href="vectorarithmetics_8h.html">vectorarithmetics.h</a>&quot;</span></div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#include &quot;<a class="code" href="svm_data_8h.html">svmData.h</a>&quot;</span></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#include &quot;<a class="code" href="svm_parser_8h.html">svmParser.h</a>&quot;</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00036" data-start="{" data-end="};">
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html">   36</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel</a>&lt;T&gt; {</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#aa2b45da4783283842e9cd42846753315">   38</a></span>        std::shared_ptr&lt;const SvmData&gt; <a class="code hl_variable" href="classmelon_1_1_support_vector_machine.html#aa2b45da4783283842e9cd42846753315">_data</a>;                       </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#aeeac5223941266357a7711260527808a">   39</a></span>        std::unique_ptr&lt;kernel::StationaryKernel&lt;double, T&gt;&gt; <a class="code hl_variable" href="classmelon_1_1_support_vector_machine.html#aeeac5223941266357a7711260527808a">_kernel</a>;   </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#ae16e1a18a7c8a6237bba83c43f31ed29">   41</a></span>        std::unique_ptr&lt;Scaler&lt;T&gt;&gt; <a class="code hl_variable" href="classmelon_1_1_support_vector_machine.html#ae16e1a18a7c8a6237bba83c43f31ed29">_inputScaler</a>;                        </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a6f2560dacef790d4668cbc27bea19178">   42</a></span>        std::unique_ptr&lt;Scaler&lt;T&gt;&gt; <a class="code hl_variable" href="classmelon_1_1_support_vector_machine.html#a6f2560dacef790d4668cbc27bea19178">_outputScaler</a>;                       </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#ad1a0be4db1d52bf32f1651142a422a22">_set_data_object</a>(std::shared_ptr&lt;const ModelData&gt; modelData) <span class="keyword">override</span>;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        T <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#ac6565c54b8f61f6ad7e03dab3f56d5b0">_calculate_prediction</a>(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, <span class="keyword">const</span> <span class="keywordtype">bool</span> fullSpace, std::vector&lt;T&gt;&amp; constraints);</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a4b02218e266feb6cced0584c6f965a96">_update_kernel</a>();</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#abf0be2b3dd923d3594af7d93eecc9ca8">   78</a></span>        <span class="keyword">virtual</span> T <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#abf0be2b3dd923d3594af7d93eecc9ca8">_decision_function</a>(std::vector&lt;T&gt; kernelValues) = 0;</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span> </div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a1cf7bc508b3f3eb3e6aa2b43578ab867">   85</a></span>        <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a1cf7bc508b3f3eb3e6aa2b43578ab867">SupportVectorMachine</a>() : <a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel</a>&lt;T&gt;(std::make_shared&lt;<a class="code hl_class" href="classmelon_1_1_svm_parser_factory.html">SvmParserFactory</a>&gt;()) {};</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a26c00f7ec0bfe43f85dc386ae4832916">   92</a></span>        <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a26c00f7ec0bfe43f85dc386ae4832916">SupportVectorMachine</a>(std::string modelName) : <a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>() { this-&gt;<a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(modelName, <a class="code hl_enumvalue" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d">MODEL_FILE_TYPE::JSON</a>); };</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a401274575c100133a03e8cbf118153d6">  101</a></span>        <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a401274575c100133a03e8cbf118153d6">SupportVectorMachine</a>(std::string modelPath, std::string modelName) : <a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>() { this-&gt;<a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(modelPath, modelName, <a class="code hl_enumvalue" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d">MODEL_FILE_TYPE::JSON</a>); };</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#afbf424b9a1b23030fd3bb259d0b67800">  108</a></span>        <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#afbf424b9a1b23030fd3bb259d0b67800">SupportVectorMachine</a>(std::shared_ptr&lt;const SvmData&gt; modelData) : <a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>() { this-&gt;<a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(modelData); };</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a2deaf0cc2520318c8208f3d552d040cf">get_fullspace_variables</a>(<span class="keywordtype">size_t</span>&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds);</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        T <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#aa24acc1421812ac374878aa9f73007c8">calculate_prediction_full_space</a>(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints);</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span> </div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        T <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#af395a6dfdc70892d7ae11ddfda45936d">calculate_prediction_reduced_space</a>(std::vector&lt;T&gt; input);</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span> </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        <span class="keywordtype">size_t</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a0b66a6ddb023bd946815e7d1b885b273">get_number_of_full_space_variables</a>();</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>    };</div>
</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00156" data-start="{" data-end="};">
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_regression.html">  156</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_support_vector_regression.html">SupportVectorRegression</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>&lt;T&gt; {</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>    <span class="keyword">private</span>:</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span> </div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        T <a class="code hl_function" href="classmelon_1_1_support_vector_regression.html#a44ff96300fb49cea7bf8d5b70c2c7104">_decision_function</a>(std::vector&lt;T&gt; input) <span class="keyword">override</span>;</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        <span class="comment">// Inherit SupportVectorMachine constructors</span></div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        <span class="keyword">using </span><a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>&lt;T&gt;<a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a1cf7bc508b3f3eb3e6aa2b43578ab867">::SupportVectorMachine</a>;</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>    };</div>
</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span> </div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00177" data-start="{" data-end="};">
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine_one_class.html">  177</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_support_vector_machine_one_class.html">SupportVectorMachineOneClass</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>&lt;T&gt; {</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>    <span class="keyword">private</span>:</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span> </div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>        T <a class="code hl_function" href="classmelon_1_1_support_vector_machine_one_class.html#a3855ffdd842f23e3df4ed1f308cc16f0">_decision_function</a>(std::vector&lt;T&gt; input) <span class="keyword">override</span>;</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <span class="comment">// Inherit SupportVectorMachine constructors</span></div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>        <span class="keyword">using </span><a class="code hl_class" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a>&lt;T&gt;<a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a1cf7bc508b3f3eb3e6aa2b43578ab867">::SupportVectorMachine</a>; }; </div>
</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span> </div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>    <span class="comment">// Sets data object containing model parameters.</span></div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00195" data-start="{" data-end="}">
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#ad1a0be4db1d52bf32f1651142a422a22">  195</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#ad1a0be4db1d52bf32f1651142a422a22">SupportVectorMachine&lt;T&gt;::_set_data_object</a>(std::shared_ptr&lt;const ModelData&gt; modelData) {</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>        <span class="comment">// Downcast the ModelData pointer to a SvmData pointer</span></div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>        _data = std::dynamic_pointer_cast&lt;const SvmData&gt;(modelData);</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>        <span class="keywordflow">if</span> (_data == <span class="keyword">nullptr</span>) {</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while loading support vector machine: Incorrect type of passed data object. The data object must be of type SvmData.&quot;</span>));</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>        }</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>        _inputScaler = <a class="code hl_function" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">ScalerFactory&lt;T&gt;::create_scaler</a>(_data-&gt;inputScalerData);</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>        _outputScaler = <a class="code hl_function" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">ScalerFactory&lt;T&gt;::create_scaler</a>(_data-&gt;outputScalerData);</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        _update_kernel();</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>    }</div>
</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span> </div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span> </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>    <span class="comment">// Loads kernel according to loaded internal parameters</span></div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00211" data-start="{" data-end="}">
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a4b02218e266feb6cced0584c6f965a96">  211</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a4b02218e266feb6cced0584c6f965a96">SupportVectorMachine&lt;T&gt;::_update_kernel</a>() {</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        <span class="keywordflow">switch</span> (_data-&gt;kernelFunction) {</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e">KERNEL_FUNCTION::RBF</a>:</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>            _kernel = std::unique_ptr&lt;kernel::KernelRBF&lt;double, T&gt;&gt;(<span class="keyword">new</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">kernel::KernelRBF&lt;double, T&gt;</a>(_data-&gt;kernelParameters.front()));</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        }</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>    }</div>
</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span> </div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>    </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>    <span class="comment">// Calculates prediction based on inputs and set constraints for fullspace formulation</span></div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00222" data-start="{" data-end="}">
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#aa24acc1421812ac374878aa9f73007c8">  222</a></span>    T <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#aa24acc1421812ac374878aa9f73007c8">SupportVectorMachine&lt;T&gt;::calculate_prediction_full_space</a>(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints) {</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        <span class="keywordflow">try</span>{</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>            <span class="keywordflow">return</span> _calculate_prediction(input, internalVariables, <span class="keyword">true</span>, constraints);</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>        }</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>        <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) {</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating support vector machine. Terminating.&quot;</span>, e));</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>        }</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>        <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating support vector machine. Terminating.&quot;</span>));</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>        }</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span> </div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>    }</div>
</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span> </div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span> </div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>    <span class="comment">// Calculates prediction based on inputs in reduced space</span></div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00239" data-start="{" data-end="}">
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#af395a6dfdc70892d7ae11ddfda45936d">  239</a></span>    T <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#af395a6dfdc70892d7ae11ddfda45936d">SupportVectorMachine&lt;T&gt;::calculate_prediction_reduced_space</a>(std::vector&lt;T&gt; input) {</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>        std::vector&lt;T&gt; dummyInternalVariables;</div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        std::vector&lt;T&gt; dummyConstraints;</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>        <span class="keywordflow">try</span>{</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>            <span class="keywordflow">return</span> _calculate_prediction(input, dummyInternalVariables, <span class="keyword">false</span>, dummyConstraints);</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        }</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>        <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) {</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating support vector machine. Terminating.&quot;</span>, e));</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        }</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating support vector machine. Terminating.&quot;</span>));</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>        }</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>    }</div>
</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span> </div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span> </div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>    <span class="comment">// Calculates prediction</span></div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00257" data-start="{" data-end="}">
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#ac6565c54b8f61f6ad7e03dab3f56d5b0">  257</a></span>    T  <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#ac6565c54b8f61f6ad7e03dab3f56d5b0">SupportVectorMachine&lt;T&gt;::_calculate_prediction</a>(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, <span class="keyword">const</span> <span class="keywordtype">bool</span> fullSpace, std::vector&lt;T&gt;&amp; constraints) {</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span> </div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>        <span class="comment">// 0: Check input dimensions</span></div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span> </div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>        <span class="keywordflow">if</span> (input.size() != _data-&gt;supportVectors.at(0).size()) {</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while calculating svm prediction: Incorrect input dimension. In reduced space mode evaluation the size of the variables vector must be equal to the input dimension of the svm.&quot;</span>);</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>        }</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>        <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>            <span class="keywordtype">size_t</span> variablesSize = get_number_of_full_space_variables();</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>            <span class="keywordflow">if</span> (internalVariables.size() != variablesSize) {</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>                <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while calculating svm prediction: Incorrect input dimension. In full space mode evaluation the size of the variables vector be equal to the number of internal variables.&quot;</span>);</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>            }</div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>        }</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span> </div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>        <span class="keyword">auto</span> variableIterator = internalVariables.begin();</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>        <span class="keywordflow">if</span> (this-&gt;_modelLoaded) {</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>            <span class="comment">// 1: Scale inputs</span></div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>        </div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>            std::vector&lt;T&gt; scaledInput = _inputScaler-&gt;scale(input);</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>            <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>                this-&gt;_set_constraints(constraints, scaledInput, variableIterator);</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>            }</div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>        </div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>            <span class="comment">// 2: Evaluate kernel for support vectors and input</span></div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span> </div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>            std::vector&lt;T&gt; kernelValues;</div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>            kernelValues.reserve(_data-&gt;supportVectors.size());</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>            <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; iSupportVector: _data-&gt;supportVectors) {</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>                T distance = _kernel-&gt;calculate_distance(iSupportVector, scaledInput);</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>                <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>                    this-&gt;_set_constraints(constraints, distance, variableIterator);</div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>                }</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span> </div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span>                T kernelValue = _kernel-&gt;evaluate_kernel(distance);</div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>                <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>                    this-&gt;_set_constraints(constraints, kernelValue, variableIterator);</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>                }</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span> </div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>                kernelValues.push_back(kernelValue);</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span>            }</div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span> </div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>            <span class="comment">// 3: Evaluate decision function</span></div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span> </div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno">  309</span>            T result = _decision_function(kernelValues);</div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span>            <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span>                this-&gt;_set_constraints(constraints, result, variableIterator);</div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>            }</div>
<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span> </div>
<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span>            <span class="comment">// 4: Descale ouput</span></div>
<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span> </div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>            T output = _outputScaler-&gt;descale({ result }).front();</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span>            <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span>                this-&gt;_set_constraints(constraints, output, variableIterator);</div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>            }</div>
<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span> </div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span>            <span class="keywordflow">return</span>  output;</div>
<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span>        }</div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span>        <span class="keywordflow">else</span> {</div>
<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>{ <span class="stringliteral">&quot;  Error while calculating support vector machine prediction: No model was loaded yet.&quot;</span> };</div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span>        }</div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span>    }</div>
</div>
<div class="line"><a id="l00329" name="l00329"></a><span class="lineno">  329</span> </div>
<div class="line"><a id="l00330" name="l00330"></a><span class="lineno">  330</span> </div>
<div class="line"><a id="l00332" name="l00332"></a><span class="lineno">  332</span>    <span class="comment">// Decision function for support vector regression.</span></div>
<div class="line"><a id="l00333" name="l00333"></a><span class="lineno">  333</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00334" data-start="{" data-end="}">
<div class="line"><a id="l00334" name="l00334"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_regression.html#a44ff96300fb49cea7bf8d5b70c2c7104">  334</a></span>    T <a class="code hl_function" href="classmelon_1_1_support_vector_regression.html#a44ff96300fb49cea7bf8d5b70c2c7104">SupportVectorRegression&lt;T&gt;::_decision_function</a>(std::vector&lt;T&gt; input) {</div>
<div class="line"><a id="l00335" name="l00335"></a><span class="lineno">  335</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">dot_product</a>(this-&gt;_data-&gt;dualCoefficients, input) + this-&gt;_data-&gt;rho;</div>
<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span>    }</div>
</div>
<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span> </div>
<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span> </div>
<div class="line"><a id="l00340" name="l00340"></a><span class="lineno">  340</span>    <span class="comment">// Decision function for one class support vector machine.</span></div>
<div class="line"><a id="l00341" name="l00341"></a><span class="lineno">  341</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00342" data-start="{" data-end="}">
<div class="line"><a id="l00342" name="l00342"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine_one_class.html#a3855ffdd842f23e3df4ed1f308cc16f0">  342</a></span>    T <a class="code hl_function" href="classmelon_1_1_support_vector_machine_one_class.html#a3855ffdd842f23e3df4ed1f308cc16f0">SupportVectorMachineOneClass&lt;T&gt;::_decision_function</a>(std::vector&lt;T&gt; input) {</div>
<div class="line"><a id="l00343" name="l00343"></a><span class="lineno">  343</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">dot_product</a>(this-&gt;_data-&gt;dualCoefficients, input) + this-&gt;_data-&gt;rho;</div>
<div class="line"><a id="l00344" name="l00344"></a><span class="lineno">  344</span>    }</div>
</div>
<div class="line"><a id="l00345" name="l00345"></a><span class="lineno">  345</span> </div>
<div class="line"><a id="l00346" name="l00346"></a><span class="lineno">  346</span>    </div>
<div class="line"><a id="l00348" name="l00348"></a><span class="lineno">  348</span>    <span class="comment">// Calculates the number of full space variables.</span></div>
<div class="line"><a id="l00349" name="l00349"></a><span class="lineno">  349</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00350" data-start="{" data-end="}">
<div class="line"><a id="l00350" name="l00350"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a0b66a6ddb023bd946815e7d1b885b273">  350</a></span>    <span class="keywordtype">size_t</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a0b66a6ddb023bd946815e7d1b885b273">SupportVectorMachine&lt;T&gt;::get_number_of_full_space_variables</a>() {</div>
<div class="line"><a id="l00351" name="l00351"></a><span class="lineno">  351</span>        <span class="keywordtype">size_t</span> variableNumber;</div>
<div class="line"><a id="l00352" name="l00352"></a><span class="lineno">  352</span>        std::vector&lt;std::string&gt; variableNames;</div>
<div class="line"><a id="l00353" name="l00353"></a><span class="lineno">  353</span>        std::vector&lt;std::pair&lt;double, double&gt;&gt; variableBounds;</div>
<div class="line"><a id="l00354" name="l00354"></a><span class="lineno">  354</span>        get_fullspace_variables(variableNumber, variableNames, variableBounds);</div>
<div class="line"><a id="l00355" name="l00355"></a><span class="lineno">  355</span>        <span class="keywordflow">return</span> variableNumber;</div>
<div class="line"><a id="l00356" name="l00356"></a><span class="lineno">  356</span>    }</div>
</div>
<div class="line"><a id="l00357" name="l00357"></a><span class="lineno">  357</span> </div>
<div class="line"><a id="l00358" name="l00358"></a><span class="lineno">  358</span> </div>
<div class="line"><a id="l00360" name="l00360"></a><span class="lineno">  360</span>    <span class="comment">// Creates variables for the full space formulation in MAiNGO.</span></div>
<div class="line"><a id="l00361" name="l00361"></a><span class="lineno">  361</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00362" data-start="{" data-end="}">
<div class="line"><a id="l00362" name="l00362"></a><span class="lineno"><a class="line" href="classmelon_1_1_support_vector_machine.html#a2deaf0cc2520318c8208f3d552d040cf">  362</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_support_vector_machine.html#a2deaf0cc2520318c8208f3d552d040cf">SupportVectorMachine&lt;T&gt;::get_fullspace_variables</a>(<span class="keywordtype">size_t</span>&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds) {</div>
<div class="line"><a id="l00363" name="l00363"></a><span class="lineno">  363</span> </div>
<div class="line"><a id="l00364" name="l00364"></a><span class="lineno">  364</span>        variableNumber = 0;</div>
<div class="line"><a id="l00365" name="l00365"></a><span class="lineno">  365</span>        variableNames.clear();</div>
<div class="line"><a id="l00366" name="l00366"></a><span class="lineno">  366</span>        variableBounds.clear();</div>
<div class="line"><a id="l00367" name="l00367"></a><span class="lineno">  367</span> </div>
<div class="line"><a id="l00368" name="l00368"></a><span class="lineno">  368</span> </div>
<div class="line"><a id="l00369" name="l00369"></a><span class="lineno">  369</span>        <span class="comment">// get max squared distance between support vectors</span></div>
<div class="line"><a id="l00370" name="l00370"></a><span class="lineno">  370</span>        <span class="keyword">auto</span> n = this-&gt;_data-&gt;supportVectors.at(0).size();</div>
<div class="line"><a id="l00371" name="l00371"></a><span class="lineno">  371</span>        <span class="keyword">auto</span> lbs = std::vector&lt;double&gt;(n, 1e6);</div>
<div class="line"><a id="l00372" name="l00372"></a><span class="lineno">  372</span>        <span class="keyword">auto</span> ubs = std::vector&lt;double&gt;(n, -1e6);</div>
<div class="line"><a id="l00373" name="l00373"></a><span class="lineno">  373</span>        <span class="keywordflow">for</span> (<span class="keyword">auto</span> iSupportVector : this-&gt;_data-&gt;supportVectors) {</div>
<div class="line"><a id="l00374" name="l00374"></a><span class="lineno">  374</span>            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; iSupportVector.size(); i++) {</div>
<div class="line"><a id="l00375" name="l00375"></a><span class="lineno">  375</span>                <span class="keyword">auto</span> xi = iSupportVector[i];</div>
<div class="line"><a id="l00376" name="l00376"></a><span class="lineno">  376</span>                <span class="keywordflow">if</span> (xi &lt; lbs[i]) lbs[i] = xi;</div>
<div class="line"><a id="l00377" name="l00377"></a><span class="lineno">  377</span>                <span class="keywordflow">if</span> (xi &gt; ubs[i]) ubs[i] = xi;</div>
<div class="line"><a id="l00378" name="l00378"></a><span class="lineno">  378</span>            }</div>
<div class="line"><a id="l00379" name="l00379"></a><span class="lineno">  379</span>        }</div>
<div class="line"><a id="l00380" name="l00380"></a><span class="lineno">  380</span>        <span class="keywordtype">double</span> maxSquaredDistance = 0;</div>
<div class="line"><a id="l00381" name="l00381"></a><span class="lineno">  381</span>        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; lbs.size(); i++) {</div>
<div class="line"><a id="l00382" name="l00382"></a><span class="lineno">  382</span>            maxSquaredDistance = maxSquaredDistance + (ubs[i] - lbs[i])*(ubs[i] - lbs[i]);</div>
<div class="line"><a id="l00383" name="l00383"></a><span class="lineno">  383</span>        }</div>
<div class="line"><a id="l00384" name="l00384"></a><span class="lineno">  384</span> </div>
<div class="line"><a id="l00385" name="l00385"></a><span class="lineno">  385</span>        <span class="comment">//std::cout &lt;&lt; &quot;Hint: Using max squared distance = &quot; &lt;&lt; maxSquaredDistance &lt;&lt; &quot;\n\n\n&quot;;</span></div>
<div class="line"><a id="l00386" name="l00386"></a><span class="lineno">  386</span> </div>
<div class="line"><a id="l00387" name="l00387"></a><span class="lineno">  387</span>        variableNumber += 2 * _data-&gt;dualCoefficients.size();</div>
<div class="line"><a id="l00388" name="l00388"></a><span class="lineno">  388</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; _data-&gt;dualCoefficients.size(); i++) {</div>
<div class="line"><a id="l00389" name="l00389"></a><span class="lineno">  389</span>            variableNames.push_back(<span class="stringliteral">&quot;squared_distance_&quot;</span> + std::to_string(i));</div>
<div class="line"><a id="l00390" name="l00390"></a><span class="lineno">  390</span>            variableNames.push_back(<span class="stringliteral">&quot;kernel_value_&quot;</span> + std::to_string(i));</div>
<div class="line"><a id="l00391" name="l00391"></a><span class="lineno">  391</span>            variableBounds.push_back(std::make_pair(0., maxSquaredDistance));</div>
<div class="line"><a id="l00392" name="l00392"></a><span class="lineno">  392</span>            variableBounds.push_back(std::make_pair(0., 1.0));</div>
<div class="line"><a id="l00393" name="l00393"></a><span class="lineno">  393</span>        }</div>
<div class="line"><a id="l00394" name="l00394"></a><span class="lineno">  394</span> </div>
<div class="line"><a id="l00395" name="l00395"></a><span class="lineno">  395</span>        <span class="keywordtype">double</span> sum_alpha = 0;</div>
<div class="line"><a id="l00396" name="l00396"></a><span class="lineno">  396</span>        <span class="keywordflow">for</span> (<span class="keyword">auto</span> alpha : this-&gt;_data-&gt;dualCoefficients) {</div>
<div class="line"><a id="l00397" name="l00397"></a><span class="lineno">  397</span>            sum_alpha = sum_alpha + alpha;</div>
<div class="line"><a id="l00398" name="l00398"></a><span class="lineno">  398</span>        }</div>
<div class="line"><a id="l00399" name="l00399"></a><span class="lineno">  399</span> </div>
<div class="line"><a id="l00400" name="l00400"></a><span class="lineno">  400</span>        variableNames.push_back(<span class="stringliteral">&quot;prediction&quot;</span>);</div>
<div class="line"><a id="l00401" name="l00401"></a><span class="lineno">  401</span>        <span class="keywordflow">if</span> (this-&gt;_data-&gt;kernelFunction == <a class="code hl_enumvalue" href="namespacemelon.html#ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e">RBF</a>) {</div>
<div class="line"><a id="l00402" name="l00402"></a><span class="lineno">  402</span>            variableBounds.push_back(std::make_pair(0, (sum_alpha - this-&gt;_data-&gt;rho)));</div>
<div class="line"><a id="l00403" name="l00403"></a><span class="lineno">  403</span>        }</div>
<div class="line"><a id="l00404" name="l00404"></a><span class="lineno">  404</span>        <span class="keywordflow">else</span> {</div>
<div class="line"><a id="l00405" name="l00405"></a><span class="lineno">  405</span>            variableBounds.push_back(std::make_pair(-1e6, 1e6));</div>
<div class="line"><a id="l00406" name="l00406"></a><span class="lineno">  406</span> </div>
<div class="line"><a id="l00407" name="l00407"></a><span class="lineno">  407</span>        }</div>
<div class="line"><a id="l00408" name="l00408"></a><span class="lineno">  408</span>        variableNumber++;</div>
<div class="line"><a id="l00409" name="l00409"></a><span class="lineno">  409</span>    }</div>
</div>
<div class="line"><a id="l00410" name="l00410"></a><span class="lineno">  410</span>}</div>
<div class="ttc" id="a_me_l_on_8h_html"><div class="ttname"><a href="_me_l_on_8h.html">MeLOn.h</a></div></div>
<div class="ttc" id="aclass_melon_exception_html"><div class="ttname"><a href="class_melon_exception.html">MelonException</a></div><div class="ttdoc">This class defines the exceptions thrown by FeedForwardNet.</div><div class="ttdef"><b>Definition</b> exceptions.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html"><div class="ttname"><a href="classmelon_1_1_melon_model.html">melon::MelonModel</a></div><div class="ttdef"><b>Definition</b> MeLOn.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a9acb78ea183bc6bf583540efcef58a0b"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">melon::MelonModel::load_model</a></div><div class="ttdeci">void load_model(std::string modelName, MODEL_FILE_TYPE fileType)</div><div class="ttdoc">Loads new model from file.</div><div class="ttdef"><b>Definition</b> MeLOn.h:114</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_factory_html_a269bf924a7c0cbafe35d32857655cb9c"><div class="ttname"><a href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">melon::ScalerFactory::create_scaler</a></div><div class="ttdeci">static std::unique_ptr&lt; Scaler&lt; T &gt; &gt; create_scaler(const std::shared_ptr&lt; const ScalerData &gt; scalerData)</div><div class="ttdoc">Factory function for creating a instance of a scaler object.</div><div class="ttdef"><b>Definition</b> scaler.h:208</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html">melon::SupportVectorMachine</a></div><div class="ttdoc">Class defining support vector machine to be used in the MAiNGO solver.</div><div class="ttdef"><b>Definition</b> svm.h:36</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a0b66a6ddb023bd946815e7d1b885b273"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a0b66a6ddb023bd946815e7d1b885b273">melon::SupportVectorMachine::get_number_of_full_space_variables</a></div><div class="ttdeci">size_t get_number_of_full_space_variables()</div><div class="ttdoc">Calculates the number of full space variables.</div><div class="ttdef"><b>Definition</b> svm.h:350</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a1cf7bc508b3f3eb3e6aa2b43578ab867"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a1cf7bc508b3f3eb3e6aa2b43578ab867">melon::SupportVectorMachine::SupportVectorMachine</a></div><div class="ttdeci">SupportVectorMachine()</div><div class="ttdoc">Default Constructor.</div><div class="ttdef"><b>Definition</b> svm.h:85</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a26c00f7ec0bfe43f85dc386ae4832916"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a26c00f7ec0bfe43f85dc386ae4832916">melon::SupportVectorMachine::SupportVectorMachine</a></div><div class="ttdeci">SupportVectorMachine(std::string modelName)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> svm.h:92</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a2deaf0cc2520318c8208f3d552d040cf"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a2deaf0cc2520318c8208f3d552d040cf">melon::SupportVectorMachine::get_fullspace_variables</a></div><div class="ttdeci">void get_fullspace_variables(size_t &amp;variableNumber, std::vector&lt; std::string &gt; &amp;variableNames, std::vector&lt; std::pair&lt; double, double &gt; &gt; &amp;variableBounds)</div><div class="ttdoc">Creates variables for the full space formulation in MAiNGO.</div><div class="ttdef"><b>Definition</b> svm.h:362</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a401274575c100133a03e8cbf118153d6"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a401274575c100133a03e8cbf118153d6">melon::SupportVectorMachine::SupportVectorMachine</a></div><div class="ttdeci">SupportVectorMachine(std::string modelPath, std::string modelName)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> svm.h:101</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a4b02218e266feb6cced0584c6f965a96"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a4b02218e266feb6cced0584c6f965a96">melon::SupportVectorMachine::_update_kernel</a></div><div class="ttdeci">void _update_kernel()</div><div class="ttdoc">Loads kernel according to loaded internal parameters.</div><div class="ttdef"><b>Definition</b> svm.h:211</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_a6f2560dacef790d4668cbc27bea19178"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#a6f2560dacef790d4668cbc27bea19178">melon::SupportVectorMachine::_outputScaler</a></div><div class="ttdeci">std::unique_ptr&lt; Scaler&lt; T &gt; &gt; _outputScaler</div><div class="ttdef"><b>Definition</b> svm.h:42</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_aa24acc1421812ac374878aa9f73007c8"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#aa24acc1421812ac374878aa9f73007c8">melon::SupportVectorMachine::calculate_prediction_full_space</a></div><div class="ttdeci">T calculate_prediction_full_space(std::vector&lt; T &gt; input, std::vector&lt; T &gt; internalVariables, std::vector&lt; T &gt; &amp;constraints)</div><div class="ttdoc">Calculates prediction based on inputs and set constraints for fullspace formulation.</div><div class="ttdef"><b>Definition</b> svm.h:222</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_aa2b45da4783283842e9cd42846753315"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#aa2b45da4783283842e9cd42846753315">melon::SupportVectorMachine::_data</a></div><div class="ttdeci">std::shared_ptr&lt; const SvmData &gt; _data</div><div class="ttdef"><b>Definition</b> svm.h:38</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_abf0be2b3dd923d3594af7d93eecc9ca8"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#abf0be2b3dd923d3594af7d93eecc9ca8">melon::SupportVectorMachine::_decision_function</a></div><div class="ttdeci">virtual T _decision_function(std::vector&lt; T &gt; kernelValues)=0</div><div class="ttdoc">Decision function used by the different types of svms.</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_ac6565c54b8f61f6ad7e03dab3f56d5b0"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#ac6565c54b8f61f6ad7e03dab3f56d5b0">melon::SupportVectorMachine::_calculate_prediction</a></div><div class="ttdeci">T _calculate_prediction(std::vector&lt; T &gt; input, std::vector&lt; T &gt; internalVariables, const bool fullSpace, std::vector&lt; T &gt; &amp;constraints)</div><div class="ttdoc">Calculates prediction.</div><div class="ttdef"><b>Definition</b> svm.h:257</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_ad1a0be4db1d52bf32f1651142a422a22"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#ad1a0be4db1d52bf32f1651142a422a22">melon::SupportVectorMachine::_set_data_object</a></div><div class="ttdeci">void _set_data_object(std::shared_ptr&lt; const ModelData &gt; modelData) override</div><div class="ttdoc">Sets data object containing model parameters.</div><div class="ttdef"><b>Definition</b> svm.h:195</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_ae16e1a18a7c8a6237bba83c43f31ed29"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#ae16e1a18a7c8a6237bba83c43f31ed29">melon::SupportVectorMachine::_inputScaler</a></div><div class="ttdeci">std::unique_ptr&lt; Scaler&lt; T &gt; &gt; _inputScaler</div><div class="ttdef"><b>Definition</b> svm.h:41</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_aeeac5223941266357a7711260527808a"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#aeeac5223941266357a7711260527808a">melon::SupportVectorMachine::_kernel</a></div><div class="ttdeci">std::unique_ptr&lt; kernel::StationaryKernel&lt; double, T &gt; &gt; _kernel</div><div class="ttdef"><b>Definition</b> svm.h:39</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_af395a6dfdc70892d7ae11ddfda45936d"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#af395a6dfdc70892d7ae11ddfda45936d">melon::SupportVectorMachine::calculate_prediction_reduced_space</a></div><div class="ttdeci">T calculate_prediction_reduced_space(std::vector&lt; T &gt; input)</div><div class="ttdoc">Calculates prediction based on inputs in reduced space.</div><div class="ttdef"><b>Definition</b> svm.h:239</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_html_afbf424b9a1b23030fd3bb259d0b67800"><div class="ttname"><a href="classmelon_1_1_support_vector_machine.html#afbf424b9a1b23030fd3bb259d0b67800">melon::SupportVectorMachine::SupportVectorMachine</a></div><div class="ttdeci">SupportVectorMachine(std::shared_ptr&lt; const SvmData &gt; modelData)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> svm.h:108</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_one_class_html"><div class="ttname"><a href="classmelon_1_1_support_vector_machine_one_class.html">melon::SupportVectorMachineOneClass</a></div><div class="ttdoc">Class defining support vector machine for one class classification to be used in the MAiNGO solver.</div><div class="ttdef"><b>Definition</b> svm.h:177</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_machine_one_class_html_a3855ffdd842f23e3df4ed1f308cc16f0"><div class="ttname"><a href="classmelon_1_1_support_vector_machine_one_class.html#a3855ffdd842f23e3df4ed1f308cc16f0">melon::SupportVectorMachineOneClass::_decision_function</a></div><div class="ttdeci">T _decision_function(std::vector&lt; T &gt; input) override</div><div class="ttdoc">Decision function for one class support vector machine.</div><div class="ttdef"><b>Definition</b> svm.h:342</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_regression_html"><div class="ttname"><a href="classmelon_1_1_support_vector_regression.html">melon::SupportVectorRegression</a></div><div class="ttdoc">Class defining support vector machine for regression to be used in the MAiNGO solver.</div><div class="ttdef"><b>Definition</b> svm.h:156</div></div>
<div class="ttc" id="aclassmelon_1_1_support_vector_regression_html_a44ff96300fb49cea7bf8d5b70c2c7104"><div class="ttname"><a href="classmelon_1_1_support_vector_regression.html#a44ff96300fb49cea7bf8d5b70c2c7104">melon::SupportVectorRegression::_decision_function</a></div><div class="ttdeci">T _decision_function(std::vector&lt; T &gt; input) override</div><div class="ttdoc">Decision function for support vector regression.</div><div class="ttdef"><b>Definition</b> svm.h:334</div></div>
<div class="ttc" id="aclassmelon_1_1_svm_parser_factory_html"><div class="ttname"><a href="classmelon_1_1_svm_parser_factory.html">melon::SvmParserFactory</a></div><div class="ttdoc">This class is a factory class for creating child instances of SvmParser.</div><div class="ttdef"><b>Definition</b> svmParser.h:74</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_r_b_f_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">melon::kernel::KernelRBF</a></div><div class="ttdoc">Implementation of Radial Basis Function kernel.</div><div class="ttdef"><b>Definition</b> kernel.h:230</div></div>
<div class="ttc" id="aexceptions_8h_html"><div class="ttname"><a href="exceptions_8h.html">exceptions.h</a></div></div>
<div class="ttc" id="akernel_8h_html"><div class="ttname"><a href="kernel_8h.html">kernel.h</a></div></div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
<div class="ttc" id="anamespacemelon_html_a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d"><div class="ttname"><a href="namespacemelon.html#a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d">melon::JSON</a></div><div class="ttdeci">@ JSON</div><div class="ttdef"><b>Definition</b> modelParser.h:33</div></div>
<div class="ttc" id="anamespacemelon_html_a9cb84438576c7ac32cbe6f10b3e9e2b3"><div class="ttname"><a href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">melon::dot_product</a></div><div class="ttdeci">auto dot_product(const std::vector&lt; T &gt; &amp;v1, const std::vector&lt; U &gt; &amp;v2)</div><div class="ttdoc">Overloaded operator for vector class allowing the calulation of dot product of two vectors.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:155</div></div>
<div class="ttc" id="anamespacemelon_html_ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e"><div class="ttname"><a href="namespacemelon.html#ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e">melon::RBF</a></div><div class="ttdeci">@ RBF</div><div class="ttdef"><b>Definition</b> svmData.h:32</div></div>
<div class="ttc" id="ascaler_8h_html"><div class="ttname"><a href="scaler_8h.html">scaler.h</a></div></div>
<div class="ttc" id="asvm_data_8h_html"><div class="ttname"><a href="svm_data_8h.html">svmData.h</a></div></div>
<div class="ttc" id="asvm_parser_8h_html"><div class="ttname"><a href="svm_parser_8h.html">svmParser.h</a></div></div>
<div class="ttc" id="avectorarithmetics_8h_html"><div class="ttname"><a href="vectorarithmetics_8h.html">vectorarithmetics.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_51db22d99c35dd018399ec0b06c30570.html">support vector machine</a></li><li class="navelem"><a class="el" href="dir_6448501517318dc42448859904d23531.html">model</a></li><li class="navelem"><a class="el" href="dir_029b1e11e365d2b6cc58f169d713c415.html">inc</a></li><li class="navelem"><a class="el" href="svm_8h.html">svm.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
